package org.rfdump;

/**
 *
 * RF Dump V1.2
 * @author Boris Wolf, Lukas Grunwald
 * @version 07/12/2004
 *
 */

import java.awt.*;
import java.awt.event.ItemEvent;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Set;
import java.util.Iterator;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JTable;
import javax.swing.JButton;
import javax.swing.JScrollPane;
import javax.swing.table.TableModel;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.JCheckBox;

public class RFIDFrame extends Frame
{
    public boolean debug = false;

    private boolean scan = false;
    private RFID rfid = null;
    private ArrayList writeBuffer = new ArrayList();

	public RFIDFrame()
	{
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		setLayout(null);
		setBackground(java.awt.Color.lightGray);
		setSize(941,600);
		setVisible(false);
		label_tagType.setText("Tag Type:");
		add(label_tagType);
		label_tagType.setForeground(java.awt.Color.black);
		label_tagType.setFont(new Font("Dialog", Font.PLAIN, 12));
		label_tagType.setBounds(24,36,84,24);
		label_tagID.setText("Tag ID:");
		add(label_tagID);
		label_tagID.setForeground(java.awt.Color.black);
		label_tagID.setFont(new Font("Dialog", Font.PLAIN, 12));
		label_tagID.setBounds(24,72,84,24);
		tf_tagType.setEditable(false);
		add(tf_tagType);
		tf_tagType.setFont(new Font("Dialog", Font.PLAIN, 12));
		tf_tagType.setBounds(108,36,156,24);
		tf_tagID.setEditable(false);
		add(tf_tagID);
		tf_tagID.setBounds(108,72,156,24);
		label_memory.setText("Memory:");
		add(label_memory);
		label_memory.setForeground(java.awt.Color.black);
		label_memory.setFont(new Font("Dialog", Font.BOLD, 12));
		label_memory.setBounds(24,144,72,24);
		bt_start.setText("START");
		bt_start.setActionCommand("START");
		add(bt_start);
		bt_start.setBounds(840,36,84,24);
		JScrollPane1.setOpaque(true);
		add(JScrollPane1);
		JScrollPane1.setBounds(24,168,900,420);
		JScrollPane1.getViewport().add(table_memory);
		table_memory.setBounds(0,0,897,0);
		tf_manufacturer.setEditable(false);
		add(tf_manufacturer);
		tf_manufacturer.setBounds(108,108,156,24);
		label_manufacturer.setText("Manufacturer:");
		add(label_manufacturer);
		label_manufacturer.setForeground(java.awt.Color.black);
		label_manufacturer.setFont(new Font("Dialog", Font.PLAIN, 12));
		label_manufacturer.setBounds(24,108,84,24);
		label_tagInfo.setText("Tag Info:");
		add(label_tagInfo);
		label_tagInfo.setForeground(java.awt.Color.black);
		label_tagInfo.setFont(new Font("Dialog", Font.BOLD, 12));
		label_tagInfo.setBounds(108,12,72,24);
		label_cookies.setText("Cookies:");
		add(label_cookies);
		label_cookies.setForeground(java.awt.Color.black);
		label_cookies.setFont(new Font("Dialog", Font.BOLD, 12));
		label_cookies.setBounds(396,12,72,24);
        tf_cookieValue.setEnabled(false);
        tf_cookieValue.setText("42424242");
		add(tf_cookieValue);
		tf_cookieValue.setBounds(396,72,156,24);
		label_cookieValue.setText("Value:");
		add(label_cookieValue);
		label_cookieValue.setForeground(java.awt.Color.black);
		label_cookieValue.setFont(new Font("Dialog", Font.PLAIN, 12));
		label_cookieValue.setBounds(312,72,84,24);
		label_cookieCounter.setText("Counter:");
		add(label_cookieCounter);
		label_cookieCounter.setForeground(java.awt.Color.black);
		label_cookieCounter.setFont(new Font("Dialog", Font.PLAIN, 12));
		label_cookieCounter.setBounds(312,108,84,24);
		tf_cookieCounter.setEditable(false);
        tf_cookieCounter.setEnabled(false);
		add(tf_cookieCounter);
		tf_cookieCounter.setBounds(396,108,156,24);
		cb_cookies.setText("Activate");
		cb_cookies.setActionCommand("Activate");
		add(cb_cookies);
		cb_cookies.setBackground(java.awt.Color.lightGray);
		cb_cookies.setFont(new Font("Dialog", Font.PLAIN, 12));
		cb_cookies.setBounds(396,36,156,24);
		setTitle("RF Dump V1.2 - www.rfdump.org");
		setResizable(false);
		//}}

		//{{INIT_MENUS
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		bt_start.addActionListener(lSymAction);
		SymItem lSymItem = new SymItem();
		cb_cookies.addItemListener(lSymItem);
		//}}
	}

	public RFIDFrame(String title)
	{
		this();
		setTitle(title);
	}

	static public void main(String args[])
	{
		(new RFIDFrame()).setVisible(true);
	}

	public void addNotify()
	{
	    // Record the size of the window prior to calling parents addNotify.
	    Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		Insets insets = getInsets();
		setSize(insets.left + insets.right + d.width, insets.top + insets.bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(insets.left, insets.top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

    // Used for addNotify check.
	boolean fComponentsAdjusted = false;

	//{{DECLARE_CONTROLS
	javax.swing.JLabel label_tagType = new javax.swing.JLabel();
	javax.swing.JLabel label_tagID = new javax.swing.JLabel();
	javax.swing.JTextField tf_tagType = new javax.swing.JTextField();
	javax.swing.JTextField tf_tagID = new javax.swing.JTextField();
	javax.swing.JLabel label_memory = new javax.swing.JLabel();
	javax.swing.JButton bt_start = new javax.swing.JButton();
	javax.swing.JScrollPane JScrollPane1 = new javax.swing.JScrollPane();
	javax.swing.JTable table_memory = new javax.swing.JTable();
	javax.swing.JTextField tf_manufacturer = new javax.swing.JTextField();
	javax.swing.JLabel label_manufacturer = new javax.swing.JLabel();
	javax.swing.JLabel label_tagInfo = new javax.swing.JLabel();
	javax.swing.JLabel label_cookies = new javax.swing.JLabel();
	javax.swing.JTextField tf_cookieValue = new javax.swing.JTextField();
	javax.swing.JLabel label_cookieValue = new javax.swing.JLabel();
	javax.swing.JLabel label_cookieCounter = new javax.swing.JLabel();
	javax.swing.JTextField tf_cookieCounter = new javax.swing.JTextField();
	javax.swing.JCheckBox cb_cookies = new javax.swing.JCheckBox();
	//}}

	//{{DECLARE_MENUS
	//}}

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == RFIDFrame.this)
				RFIDFrame_WindowClosing(event);
		}
	}

	void RFIDFrame_WindowClosing(java.awt.event.WindowEvent event)
	{
		setVisible(false);		 // hide the Frame
        if (scan) scan = false;
        rfid.close();
        System.exit(0);
	}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == bt_start)
				btStart_actionPerformed(event);
		}
	}

    private void writePendingPages() {

        while (this.writeBuffer.size()>0) {
            String buffer = (String)writeBuffer.remove(0);
            String adr = buffer.substring(0,2);
            String value = buffer.substring(2);
            System.out.println("WRITING 0x" + adr + ": " + value);
            rfid.writePage(adr, value);
        }
    }

	void btStart_actionPerformed(java.awt.event.ActionEvent event)
	{

        if (scan) {

            scan = false;
            bt_start.setText("START");

        } else {

            scan = true;
            bt_start.setText("STOP");

            final SwingWorker worker = new SwingWorker() {

                public Object construct() {

                    String currentTagID = "";

                    if (rfid == null)
                        rfid = new RFID();

                    rfid.reset();

                    String version = rfid.getVersion();

                    if (debug) System.out.println("VERSION:\t" + version);

                    while (scan) {

                        try {Thread.sleep(100);} catch (Exception e) {}

                        writePendingPages();

                        String select = rfid.select();

                        if (debug) System.out.println("SELECT:\t" + select);

                        String errMsg = rfid.getErrorMsg(select);

                        if (errMsg != null) {

                            if (debug) System.out.println("ERROR:\t" + errMsg);

                        } else {

                            // read tag info

                            String tagType = rfid.getTagTypeName(select);
                            if (debug) System.out.println("TYPE:\t" + tagType);
                            tf_tagType.setText(tagType);

                            String tagID = rfid.getTagID(select);
                            if (debug) System.out.println("TAGID:\t" + tagID);
                            tf_tagID.setText(tagID);

                            String tagMfr = rfid.getTagManufacturerName(select);
                            if (debug) System.out.println("TAGMFR:\t" + tagMfr);
                            tf_manufacturer.setText(tagMfr);

                            if (!tagID.equals(currentTagID)) {

                                if (debug) System.out.println("NEW TAG FOUND: READING MEMORY");
                                currentTagID = tagID;

                                int adr = 0;
                                ArrayList memory = new ArrayList();

                                RFIDTableModel tableModel = new RFIDTableModel(memory, writeBuffer);
                                table_memory.setModel(tableModel);

                                // column widths

                                table_memory.getColumnModel().getColumn(0).setPreferredWidth(15);
                                table_memory.getColumnModel().getColumn(9).setPreferredWidth(200);

                                for (int i=1; i<=8; i++)
                                    table_memory.getColumnModel().getColumn(i).setPreferredWidth(30);


                                // column renderes

                                RFIDTableCellRenderer rendererAdr = new RFIDTableCellRenderer();
                                //rendererAdr.setBackground(Color.magenta);

                                RFIDTableCellRenderer rendererHex = new RFIDTableCellRenderer();
                                rendererHex.setBackground(Color.cyan);

                                RFIDTableCellRenderer rendererASCII = new RFIDTableCellRenderer();
                                //rendererASCII.setBackground(Color.cyan);

                                table_memory.getColumnModel().getColumn(0).setCellRenderer(rendererAdr);
                                table_memory.getColumnModel().getColumn(9).setCellRenderer(rendererASCII);

                                for (int i=1; i<=8; i++)
                                    table_memory.getColumnModel().getColumn(i).setCellRenderer(rendererHex);

                                // read tag memory

                                while (errMsg == null) {

                                    writePendingPages();

                                    String hexAdr = Integer.toHexString(adr);

                                    // only two-digit adresses are possible

                                    if (hexAdr.equals("100"))
                                        break;

                                    if (hexAdr.length() == 1)
                                        hexAdr = "0" + hexAdr;

                                    String page = rfid.readPage(hexAdr);

                                    errMsg = rfid.getErrorMsg(page);

                                    if (errMsg != null) {
                                        if (debug) System.out.println(hexAdr + ":\t" + errMsg);
                                    }   else {
                                        if (debug) System.out.println(hexAdr + ":\t" + page);
                                        tableModel.append(page);
                                    }

                                    if (!scan) break;

                                    adr++;
                                }

                                // set cookie

                                if (cb_cookies.isSelected() && scan) {

                                    // check for cookie page

                                    int cookieAdr = adr-4;
                                    String cookie = rfid.readPage(cookieAdr);

                                    if (cookie.equals(tf_cookieValue.getText())) {

                                        // if cookie present increment counter

                                        if (debug) System.out.println("COOKIE FOUND");
                                        int counter = new Integer(rfid.readPage(cookieAdr+1)).intValue();
                                        counter++;
                                        tableModel.setValueAt(counter+"",cookieAdr+1);

                                    } else {

                                        // if not present initialize cookie

                                        if (debug) System.out.println("SETTING COOKIE");
                                        tableModel.setValueAt(tf_cookieValue.getText(),cookieAdr);
                                        tableModel.setValueAt("00000000",cookieAdr+1);
                                    }
                                }
                            }
                        }
                    }

                    return null;
                }
            };

            worker.start();
        }
	}

	class SymItem implements java.awt.event.ItemListener
	{
		public void itemStateChanged(java.awt.event.ItemEvent event)
		{
			Object object = event.getSource();
			if (object == cb_cookies)
				cb_cookies_itemStateChanged(event);
		}
	}

	void cb_cookies_itemStateChanged(java.awt.event.ItemEvent event)
	{
        if (event.getStateChange() == ItemEvent.SELECTED) {

            this.tf_cookieCounter.setEnabled(true);
            this.tf_cookieValue.setEnabled(true);

        } else if (event.getStateChange() == ItemEvent.DESELECTED) {

            this.tf_cookieCounter.setEnabled(false);
            this.tf_cookieValue.setEnabled(false);
        }
    }
}
